Index: pjproject/trunk/third_party/build/portaudio/libportaudio.vcp
===================================================================
--- pjproject/trunk/third_party/build/portaudio/libportaudio.vcp	(revision 1250)
+++ pjproject/trunk/third_party/build/portaudio/libportaudio.vcp	(revision 1252)
@@ -892,9 +892,7 @@
 
 DEP_CPP_PA_AL=\
-	"..\..\portaudio\src\common\pa_allocation.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_AL=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_allocation.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -1169,11 +1167,9 @@
 
 DEP_CPP_PA_CO=\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_endianness.h"\
-	"..\..\portaudio\src\common\pa_types.h"\
-	
-NODEP_CPP_PA_CO=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_converters.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_endianness.h"\
+	"..\..\portaudio\src\common\pa_types.h"\
 	
 
@@ -1426,9 +1422,7 @@
 
 DEP_CPP_PA_CP=\
-	"..\..\portaudio\src\common\pa_cpuload.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_CP=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_cpuload.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2063,13 +2057,11 @@
 
 DEP_CPP_PA_FR=\
-	"..\..\portaudio\src\common\pa_endianness.h"\
-	"..\..\portaudio\src\common\pa_hostapi.h"\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	"..\..\portaudio\src\common\pa_trace.h"\
-	"..\..\portaudio\src\common\pa_types.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_FR=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_endianness.h"\
+	"..\..\portaudio\src\common\pa_hostapi.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
+	"..\..\portaudio\src\common\pa_trace.h"\
+	"..\..\portaudio\src\common\pa_types.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2368,11 +2360,9 @@
 
 DEP_CPP_PA_PR=\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_process.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_PR=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_converters.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_process.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2727,15 +2717,13 @@
 
 DEP_CPP_PA_SK=\
-	"..\..\portaudio\src\common\pa_allocation.h"\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_cpuload.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\common\pa_hostapi.h"\
-	"..\..\portaudio\src\common\pa_process.h"\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	"..\..\portaudio\src\common\pa_util.h"\
-	
-NODEP_CPP_PA_SK=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_allocation.h"\
+	"..\..\portaudio\src\common\pa_converters.h"\
+	"..\..\portaudio\src\common\pa_cpuload.h"\
+	"..\..\portaudio\src\common\pa_dither.h"\
+	"..\..\portaudio\src\common\pa_hostapi.h"\
+	"..\..\portaudio\src\common\pa_process.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
+	"..\..\portaudio\src\common\pa_util.h"\
 	
 
@@ -2995,8 +2983,6 @@
 
 DEP_CPP_PA_ST=\
-	"..\..\portaudio\src\common\pa_stream.h"\
-	
-NODEP_CPP_PA_ST=\
-	"..\..\portaudio\src\common\portaudio.h"\
+	"..\..\portaudio\include\portaudio.h"\
+	"..\..\portaudio\src\common\pa_stream.h"\
 	
 
@@ -3809,249 +3795,4 @@
 	"..\..\portaudio\include\portaudio.h"\
 	"..\..\portaudio\src\common\pa_util.h"\
-	
-
-!ENDIF 
-
-# End Source File
-# Begin Source File
-
-SOURCE=..\..\portaudio\src\os\win\pa_x86_plain_converters.c
-
-!IF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII_FP) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII_FP) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\include\portaudio.h"\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSII) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH4) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH4) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH3) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE SH3) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE emulator) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE emulator) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\include\portaudio.h"\
-	"..\..\portaudio\src\common\pa_converters.h"\
-	"..\..\portaudio\src\common\pa_dither.h"\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4I) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4I) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV_FP) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPSIV_FP) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPS16) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE MIPS16) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4T) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE ARMV4T) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE x86) Release"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
-	
-
-!ELSEIF  "$(CFG)" == "libportaudio - Win32 (WCE x86) Debug"
-
-DEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_x86_plain_converters.h"\
-	
-NODEP_CPP_PA_X8=\
-	"..\..\portaudio\src\os\win\pa_converters.h"\
-	"..\..\portaudio\src\os\win\pa_dither.h"\
 	
 