Index: /pjproject/trunk/build.symbian/bld.inf
===================================================================
--- /pjproject/trunk/build.symbian/bld.inf	(revision 1252)
+++ /pjproject/trunk/build.symbian/bld.inf	(revision 1253)
@@ -10,3 +10,5 @@
 //pjlib_test.mmp
 //sipstateless.mmp
+pjsua_lib.mmp
+null_audio.mmp
 symbian_ua.mmp
Index: /pjproject/trunk/build.symbian/null_audio.mmp
===================================================================
--- /pjproject/trunk/build.symbian/null_audio.mmp	(revision 1253)
+++ /pjproject/trunk/build.symbian/null_audio.mmp	(revision 1253)
@@ -0,0 +1,23 @@
+TARGET 		null_audio.lib
+TARGETTYPE 	lib
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjmedia\src\pjmedia
+
+OPTION		CW -lang c++
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+
+//
+// Platform independent source
+//
+SOURCE		nullsound.c
+
+SYSTEMINCLUDE	..\pjlib\include
+SYSTEMINCLUDE	..\pjmedia\include
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
Index: /pjproject/trunk/build.symbian/pjproject.cww
===================================================================
--- /pjproject/trunk/build.symbian/pjproject.cww	(revision 1252)
+++ /pjproject/trunk/build.symbian/pjproject.cww	(revision 1253)
@@ -240,4 +240,29 @@
         <SESSION>-1</SESSION>
         <EDOCTYPE>0</EDOCTYPE>
+        <PATH USERELATIVEPATHS = "true">null_audio.mcp</PATH>
+        <FRAMELOC>
+            <X>0</X>
+            <Y>0</Y>
+        </FRAMELOC>
+        <FRAMESIZE>
+            <W>347</W>
+            <H>128</H>
+        </FRAMESIZE>
+        <DOCKINFO>
+            <STATUS>1</STATUS>
+            <ROW>0</ROW>
+            <COLUMN>0</COLUMN>
+            <DOCKBARID>59420</DOCKBARID>
+            <PCTWIDTH>1.000000</PCTWIDTH>
+            <HGT>294</HGT>
+            <GROUPID>
+                <GIDHIGHPART>4294967294</GIDHIGHPART>
+                <GIDLOWPART>4294967294</GIDLOWPART>
+            </GROUPID>
+        </DOCKINFO>
+    </WINDOW>
+    <WINDOW>
+        <SESSION>-1</SESSION>
+        <EDOCTYPE>0</EDOCTYPE>
         <PATH USERELATIVEPATHS = "true">symbian_ua.mcp</PATH>
         <FRAMELOC>
@@ -263,15 +288,13 @@
     </WINDOW>
     <WINDOW>
-        <SESSION>-1</SESSION>
-        <EDOCTYPE>1</EDOCTYPE>
-        <PATH USERELATIVEPATHS = "true">..\pjsip-apps\src\symbian_ua\ua.cpp</PATH>
-        <MAXIMIZED>true</MAXIMIZED>
+        <SESSION>-2147483648</SESSION>
+        <EDOCTYPE>36</EDOCTYPE>
         <FRAMELOC>
             <X>4</X>
-            <Y>4</Y>
-        </FRAMELOC>
-        <FRAMESIZE>
-            <W>629</W>
-            <H>859</H>
+            <Y>23</Y>
+        </FRAMELOC>
+        <FRAMESIZE>
+            <W>534</W>
+            <H>921</H>
         </FRAMESIZE>
         <DOCKINFO>
@@ -290,6 +313,5 @@
     <WINDOW>
         <SESSION>-2147483648</SESSION>
-        <EDOCTYPE>36</EDOCTYPE>
-        <DEFAULT>true</DEFAULT>
+        <EDOCTYPE>20</EDOCTYPE>
         <FRAMELOC>
             <X>4</X>
@@ -297,6 +319,6 @@
         </FRAMELOC>
         <FRAMESIZE>
-            <W>534</W>
-            <H>921</H>
+            <W>1008</W>
+            <H>2142</H>
         </FRAMESIZE>
         <DOCKINFO>
@@ -315,13 +337,12 @@
     <WINDOW>
         <SESSION>-2147483648</SESSION>
-        <EDOCTYPE>20</EDOCTYPE>
-        <DEFAULT>true</DEFAULT>
-        <FRAMELOC>
-            <X>4</X>
-            <Y>23</Y>
-        </FRAMELOC>
-        <FRAMESIZE>
-            <W>1008</W>
-            <H>2142</H>
+        <EDOCTYPE>23</EDOCTYPE>
+        <FRAMELOC>
+            <X>6</X>
+            <Y>81</Y>
+        </FRAMELOC>
+        <FRAMESIZE>
+            <W>566</W>
+            <H>477</H>
         </FRAMESIZE>
         <DOCKINFO>
@@ -338,27 +359,3 @@
         </DOCKINFO>
     </WINDOW>
-    <WINDOW>
-        <SESSION>-2147483648</SESSION>
-        <EDOCTYPE>23</EDOCTYPE>
-        <FRAMELOC>
-            <X>6</X>
-            <Y>81</Y>
-        </FRAMELOC>
-        <FRAMESIZE>
-            <W>566</W>
-            <H>477</H>
-        </FRAMESIZE>
-        <DOCKINFO>
-            <STATUS>0</STATUS>
-            <ROW></ROW>
-            <COLUMN></COLUMN>
-            <DOCKBARID></DOCKBARID>
-            <PCTWIDTH></PCTWIDTH>
-            <HGT></HGT>
-            <GROUPID>
-                <GIDHIGHPART></GIDHIGHPART>
-                <GIDLOWPART></GIDLOWPART>
-            </GROUPID>
-        </DOCKINFO>
-    </WINDOW>
 </MWIDEWORKSPACE>
Index: /pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1252)
+++ /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1253)
@@ -26,5 +26,5 @@
 
 LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib eexe.lib
-STATICLIBRARY   pjsua_lib.lib pjsip_ua.lib pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib pjnath.lib pjlib_util.lib pjlib.lib ecrt0.lib
+STATICLIBRARY   null_audio.lib pjsua_lib.lib pjsip_ua.lib pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib pjnath.lib pjlib_util.lib pjlib.lib ecrt0.lib
 CAPABILITY	None
 
Index: /pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1252)
+++ /pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1253)
@@ -93,7 +93,4 @@
 #   define PJSIP_UDP_SO_SNDBUF_SIZE	4000
 #   define PJSIP_UDP_SO_RCVBUF_SIZE	4000
-#   define PJSIP_AUTH_HEADER_CACHING	0
-#   define PJSIP_AUTH_AUTO_SEND_NEXT	0
-#   define PJSIP_AUTH_QOP_SUPPORT	0
 #   define PJMEDIA_HAS_LARGE_FILTER	0
 #   define PJMEDIA_HAS_SMALL_FILTER	0
@@ -122,6 +119,4 @@
 
 #   define PJSUA_MAX_CALLS		512
-#   define PJSIP_AUTH_HEADER_CACHING	1
-#   define PJSIP_AUTH_AUTO_SEND_NEXT	1
 
 #endif